#B64 encodes from and to HP45 controller based B64
#from 0-63: ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/
#signs can be used as follows: -L2a, making the L2a number negative

#todo:
#Make arrat functions from and to B64

def B64ToLookup(temp_input):
    """Takes a value between 0 and 63 and returns a character"""
    #constrain values
    if (temp_input < 0):
        temp_input = 0
    if (temp_input > 63):
        temp_input = 63
        
    temp_return = ""
    #make B64 array
    temp_b64 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
    temp_return += temp_b64[temp_input]
    return temp_return
    
def B64ToSingle(temp_input):
    """Takes a value, and turns it to a string containing the value in B64"""
    temp_return_value = ""
    temp_negative = 1
    temp_convert = 0
    if (temp_input < 0): #if value is negative
        temp_negative = -1 #add a minus
        temp_input *= -1 #make positive
    
    #add 6 bits at a time to value
    while (True):
        temp_convert = temp_input & 63 #take 6 LSBits
        temp_return_value += B64ToLookup(temp_convert) #add to return
        temp_input = temp_input >> 6 #shift 6 bits
        
        if (temp_input == 0):
            break
    
    if (temp_negative == -1):
        temp_return_value += '-'
        
    temp_return_value = temp_return_value[::-1]
    return temp_return_value

def B64ToArray(temp_input): 
    """Takes an array of 1's and 0's and turns it into a string of B64"""
    temp_return_value = ""
    temp_value = 0
    temp_output = 0
    temp_counter = 0
    temp_b6 = 0
    while (True):
        temp_value = temp_input[temp_counter] & 1 #add LSB of value
        temp_value = temp_value << temp_b6 #shift bits
        temp_output = temp_output | temp_value #add to output value
        temp_value = 0 #reset value
        temp_b6 = temp_b6 + 1 #add one to b6 counter
        temp_counter = temp_counter + 1 #add one to overal counter
        if (temp_b6 >= 6 or temp_counter >= len(temp_input)): #if value is six, reset to 0, add value
            temp_b6 = 0 
            temp_return_value += B64ToLookup(temp_output)
            temp_output = 0 #reset output value
            
            if (temp_counter >= len(temp_input)): #if break conditions
                #temp_return_value = temp_return_value [::-1] #reverse value (Needed?)
                return temp_return_value #return value
        
    
    
def B64FromLookup(temp_input):
    """Takes a B64 value and turn it to decimal 0-63"""
    temp_input = ord(temp_input) #convert to ascii value
    if (temp_input >= ord('A') and temp_input <= ord('Z')): return temp_input - ord('A') #0-25
    if (temp_input >= ord('a') and temp_input <= ord('z')): return temp_input - 71 #26-51
    if (temp_input >= ord('0') and temp_input <= ord('9')): return temp_input + 4 #52-61
    if (temp_input == ord('+')): return 62 #62
    if (temp_input == ord('/')): return 63 #63
    return -1 #-1
    
def B64FromSingle(temp_input):
    """takes a string of B64 and turns it into a real value"""
    if (len(temp_input) > 0):
        temp_return_value = 0
        temp_negative = 1
        temp_order = 1
        if (temp_input[0] == '-'):
            temp_negative = -1
            #print("minus found")
            
        if (len(temp_input) == 0): #if after strip no characters are left
            return
            
        temp_input = temp_input[::-1] #reverse string
            
        while (True):
            #print("Parsing: " + str(temp_input[0]))
            temp_val = B64FromLookup(temp_input[0])
            if (temp_val != -1):
                #print("modified to: " + str(temp_val))
                temp_return_value += (temp_val * temp_order)
                #print("Total so far: " + str(temp_return_value))
                temp_order *= 64 #add next order of magnitude
                temp_input = temp_input[1:] #remove first character
            else:
                temp_return_value *= temp_negative
                return temp_return_value
            
            if (len(temp_input) <= 0):
                temp_return_value *= temp_negative
                return temp_return_value
    
    
def B64FromArray(temp_input):
    """Takes a string of B64 and turns it into an array of values"""
    #temp_return_value[] 
    
    

if __name__ == '__main__':
    print(B64ToLookup(12)) #tested working
    print(B64ToSingle(-129)) #tested working
    print(B64ToArray([1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1])) #tested working
    print(B64FromLookup('0')) #tested working
    print(B64FromSingle("-BA"))
    print(B64FromSingle("ah9"))
    print('finished')

