##The interface holds the user interface for Oasis controller

#Todo list
#-Add status bar or status window to give updates that are now given
#in the comandline
#-Add X, Y, F, and B together with status in the GRBL section
#-Add Position of carriage to printhead section


import sys
from PyQt5.QtWidgets import (QWidget, QLabel, QLineEdit, QTextEdit,
    QTextEdit, QGridLayout, QApplication, QPushButton, QDesktopWidget)
from PyQt5.QtGui import QIcon, QPixmap, QFont



class Interface(QWidget):
    def __init__(self):
        super().__init__()
        #self.initUI()
        
    def initUI(self):	
        grid = QGridLayout()
        self.setLayout(grid)
        
        #set labels
        self.motion_title = QLabel('Motion Connection', self)
        self.inkjet_title = QLabel('Inkjet Connection', self) 
        self.motion_function_title = QLabel('Motion Functions', self)   
        self.inkjet_function_title = QLabel('Inkjet Functions', self)
        
        self.motion_x_pos_title = QLabel('X Position', self)
        self.motion_y_pos_title = QLabel('Y Position', self)
        self.motion_f_pos_title = QLabel('F Position', self)
        self.motion_b_pos_title = QLabel('B Position', self)
        self.motion_state_title = QLabel('State', self)
        
        self.inkjet_pos_title = QLabel('Position', self)
        self.inkjet_temp_title = QLabel('Temperature', self)
        
        #Set buttons	
        self.motion_connect = QPushButton('Connect', self)
        self.motion_send_line = QPushButton('Send', self)
        self.inkjet_connect = QPushButton('Connect', self)
        self.inkjet_send_line = QPushButton('Send', self)
        self.motion_home = QPushButton('Home', self)
        self.motion_xp = QPushButton('X+', self)
        self.motion_xn = QPushButton('X-', self)
        self.motion_yp = QPushButton('Y+', self)
        self.motion_yn = QPushButton('Y-', self)
        self.inkjet_set_pos = QPushButton('Set Position', self)
        self.inkjet_preheat = QPushButton('Preheat', self)
        self.inkjet_set_dpi = QPushButton('Set DPI', self)
        
        #set input lineedits
        self.motion_set_port = QLineEdit(self)
        self.motion_write_line = QLineEdit(self)
        self.inkjet_set_port = QLineEdit(self)
        self.inkjet_write_line = QLineEdit(self)
        self.inkjet_dpi = QLineEdit(self)
        #self.motion_speed = QLineEdit(self)
        
        #set output textedits
        self.motion_serial_output = QTextEdit(self)
        self.motion_serial_output.setReadOnly(True)
        self.motion_serial_output.setLineWrapMode(QTextEdit.NoWrap)
        self.motion_serial_input = QTextEdit(self)
        self.motion_serial_input.setReadOnly(True)
        self.motion_serial_input.setLineWrapMode(QTextEdit.NoWrap)
        
        self.inkjet_serial_output = QTextEdit(self)
        self.inkjet_serial_output.setReadOnly(True)
        self.inkjet_serial_output.setLineWrapMode(QTextEdit.NoWrap)
        self.inkjet_serial_input = QTextEdit(self)
        self.inkjet_serial_input.setReadOnly(True)
        self.inkjet_serial_input.setLineWrapMode(QTextEdit.NoWrap)
        
        #output lineedits
        self.motion_x_pos = QLineEdit(self)
        self.motion_x_pos.setReadOnly(True)
        self.motion_y_pos = QLineEdit(self)
        self.motion_y_pos.setReadOnly(True)
        self.motion_f_pos = QLineEdit(self)
        self.motion_f_pos.setReadOnly(True)
        self.motion_b_pos = QLineEdit(self)
        self.motion_b_pos.setReadOnly(True)
        self.motion_state = QLineEdit(self)
        self.motion_state.setReadOnly(True)
        
        self.inkjet_pos = QLineEdit(self)
        self.inkjet_pos.setReadOnly(True)
        self.inkjet_temperature = QLineEdit(self)
        self.inkjet_temperature.setReadOnly(True)
        
        #create image objects
        self.input_window = QLabel(self)
        self.output_window = QLabel(self) 
         
        
        #fix to grid  
        grid.addWidget(self.input_window,0,0,12,12) 
        grid.addWidget(self.output_window,0,12,12,12)
        
        grid.addWidget(self.motion_title,0,24,2,12) 
        grid.addWidget(self.motion_set_port,2,24,2,8) 
        grid.addWidget(self.motion_connect,2,32,2,4)
        grid.addWidget(self.motion_serial_output,4,24,4,12)
        grid.addWidget(self.motion_write_line,8,24,2,8) 
        grid.addWidget(self.motion_send_line,8,32,2,4)
        grid.addWidget(self.motion_serial_input,10,24,2,12)
        
        grid.addWidget(self.inkjet_title,12,24,2,12) 
        grid.addWidget(self.inkjet_set_port,14,24,2,8) 
        grid.addWidget(self.inkjet_connect,14,32,2,4)
        grid.addWidget(self.inkjet_serial_output,16,24,4,12)
        grid.addWidget(self.inkjet_write_line,20,24,2,8) 
        grid.addWidget(self.inkjet_send_line,20,32,2,4)
        grid.addWidget(self.inkjet_serial_input,22,24,2,12)
        
        grid.addWidget(self.motion_function_title,12,0,1,12)
        grid.addWidget(self.motion_home,14,0,1,2)
        #grid.addWidget(self.motion_speed,14,4,1,2)
        grid.addWidget(self.motion_yp,14,2,1,2)
        grid.addWidget(self.motion_yn,17,2,1,2)
        grid.addWidget(self.motion_xp,16,4,1,2)
        grid.addWidget(self.motion_xn,16,0,1,2)
        grid.addWidget(self.motion_x_pos_title,20,0,1,2)
        grid.addWidget(self.motion_y_pos_title,21,0,1,2)
        grid.addWidget(self.motion_f_pos_title,22,0,1,2)
        grid.addWidget(self.motion_b_pos_title,23,0,1,2)
        grid.addWidget(self.motion_state_title,24,0,1,2)
        grid.addWidget(self.motion_x_pos,20,2,1,4)
        grid.addWidget(self.motion_y_pos,21,2,1,4)
        grid.addWidget(self.motion_f_pos,22,2,1,4)
        grid.addWidget(self.motion_b_pos,23,2,1,4)
        grid.addWidget(self.motion_state,24,2,1,4)
        
        grid.addWidget(self.inkjet_function_title,12,12,1,12)
        grid.addWidget(self.inkjet_set_pos, 14,12,1,2)
        grid.addWidget(self.inkjet_preheat, 14,14,1,2)
        grid.addWidget(self.inkjet_dpi, 16,12,1,4)
        grid.addWidget(self.inkjet_set_dpi, 16,16,1,2)
        grid.addWidget(self.inkjet_pos_title,20,12,1,2)
        grid.addWidget(self.inkjet_temp_title,21,12,1,2)
        grid.addWidget(self.inkjet_pos,20,14,1,4)
        grid.addWidget(self.inkjet_temperature,21,14,1,4)
        
        
        self.setFixedSize(1200, 800)
        self.center()
        self.setWindowTitle('Oasis Controller')
        self.setWindowIcon(QIcon('yteclogo.png')) 
        self.show()
    def center(self):
        qr = self.frameGeometry()
        cp = QDesktopWidget().availableGeometry().center()
        qr.moveCenter(cp)
        self.move(qr.topLeft())

if __name__ == '__main__':
    app = QApplication(sys.argv)
    ex = Interface()
    sys.exit(app.exec_())
    

    
    
